package ru.ulstu.extractor.heuristic.service;

import org.springframework.stereotype.Service;
import ru.ulstu.extractor.heuristic.component.BuildTool;

import java.io.File;
import java.util.List;
import java.util.Optional;

@Service
public class BuildToolService {
    private final List<BuildTool> buildTools;

    public BuildToolService(List<BuildTool> buildTools) {
        this.buildTools = buildTools;
    }

    public Optional<BuildTool> getProjectBuildTool(List<File> rootProjectFiles) {
        return buildTools.stream().filter(buildTool -> buildTool.canAppliedToProject(rootProjectFiles)).findAny();
    }
}
