package ru.ulstu.extractor.heuristic.service;

import org.springframework.stereotype.Service;
import ru.ulstu.extractor.heuristic.component.ProgrammingLanguage;

import java.util.List;
import java.util.Optional;

@Service
public class ProgrammingLanguageService {
    private final List<ProgrammingLanguage> programmingLanguages;

    public ProgrammingLanguageService(List<ProgrammingLanguage> programmingLanguages) {
        this.programmingLanguages = programmingLanguages;
    }

    public Optional<ProgrammingLanguage> getByName(String programmingLanguageName) {
        return programmingLanguages.stream().filter(lang -> lang.canMappedByName(programmingLanguageName)).findAny();
    }
}
