package ru.ulstu.extractor.markup.model;

import ru.ulstu.extractor.rule.model.AntecedentValue;
import ru.ulstu.extractor.ts.model.TimeSeries;
import ru.ulstu.extractor.ts.model.TimeSeriesType;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class TimeSeriesForMarkup {
    //output
    private Map<TimeSeries, AntecedentValue> timeSeriesTendencyMap = new HashMap<>();
    private Date dateFrom;
    private Date dateTo;

    //input
    private List<TimeSeriesType> timeSeriesTypes;
    private List<AntecedentValue> antecedentValues;
    private String markup;

    public TimeSeriesForMarkup() {
    }

    public TimeSeriesForMarkup(TimeSeries ts1, AntecedentValue tendency1, TimeSeries ts2, AntecedentValue tendency2, Date dateFrom, Date dateTo) {
        this.dateFrom = dateFrom;
        this.dateTo = dateTo;
        this.timeSeriesTendencyMap.put(ts1, tendency1);
        this.timeSeriesTendencyMap.put(ts2, tendency2);
        refresh();
    }

    public Map<TimeSeries, AntecedentValue> getTimeSeriesTendencyMap() {
        return timeSeriesTendencyMap;
    }

    public Date getDateFrom() {
        return dateFrom;
    }

    public void setDateFrom(Date dateFrom) {
        this.dateFrom = dateFrom;
    }

    public Date getDateTo() {
        return dateTo;
    }

    public void setDateTo(Date dateTo) {
        this.dateTo = dateTo;
    }

    public String getMarkup() {
        return markup;
    }

    public void setTimeSeriesTendencyMap(Map<TimeSeries, AntecedentValue> timeSeriesTendencyMap) {
        this.timeSeriesTendencyMap = timeSeriesTendencyMap;
    }

    public void setMarkup(String markup) {
        this.markup = markup;
    }

    public List<TimeSeriesType> getTimeSeriesTypes() {
        return timeSeriesTypes;
    }

    public void setTimeSeriesTypes(List<TimeSeriesType> timeSeriesTypes) {
        this.timeSeriesTypes = timeSeriesTypes;
    }

    public List<AntecedentValue> getAntecedentValues() {
        return antecedentValues;
    }

    public void setAntecedentValues(List<AntecedentValue> antecedentValues) {
        this.antecedentValues = antecedentValues;
    }

    public void refresh() {
        this.antecedentValues = new ArrayList<>(timeSeriesTendencyMap.values());
        this.timeSeriesTypes = timeSeriesTendencyMap.keySet().stream().map(TimeSeries::getTimeSeriesType).collect(Collectors.toList());
    }
}
